#include "Geist.h"
#include "Spieler.h"

GeistEffect::GeistEffect( ResourceRegistry *zResources, Spieler *zSpieler )
    : Effect( zSpieler, 5.f + ( 5.f / 100.f ) * zSpieler->getAbklingZeitVerringerung() )
{
    bild = zResources->zResource( R_GEIST, 0 )->getImage( 0 );
}

GeistEffect::~GeistEffect()
{
    bild->release();
}

bool GeistEffect::istSpielerSichtbar( Team *zTeam ) const
{
    return zTeam == zSpieler->zTeam();
}

bool GeistEffect::istIntersectable() const
{
    return 0;
}

void GeistEffect::renderSpieler( Bild &rObj )
{
    if( rObj.setDrawOptions( (int)zSpieler->getX(), (int)zSpieler->getY(), (int)zSpieler->getWidth(), (int)zSpieler->getHeight() ) )
    {
        rObj.alphaBildSkall( 0, 0, (int)zSpieler->getWidth(), (int)zSpieler->getHeight(), *bild );
        rObj.releaseDrawOptions();
    }
}